/* *****************************************************************************
 * pather.h 1.12: world navigation routines.                                   * 
 * This code was originally written in 1995 as a standalone tool.  Ported into *
 * LO in 2011 under The Last Outpost Project license.                          *
 * version 1.12 is released by the author rahjiii@jeffrika.com under LGPL      *
 ***************************************************************************** */


#ifndef LO_PATHER_H
#define LO_PATHER_H

/* mode bits to control the path style. */
#define PATH_STAYZONE (1<<0)
#define PATH_NOSWIM (1<<1)
#define PATH_NOLOCKED (1<<2)
#define PATH_NOCLOSED (1<<3)
#define PATH_NOMOVELOSS (1<<4)
#define PATH_OKPORTAL (1<<5)
#define PATH_OKDYNAMIC (1<<6)
#define PATH_DEFAULT 0

/* structure definitions */
struct whichway_cache_struct {
		int from;
		int to;
		int mode;
		time_t expires;
		int whichway;
};

struct allpoints {
	sh_int dist;
	sh_int camefrom;
	byte bygoing;
	byte known;
};

/* exported functions */
char *compressed_directions(char *path);
char *run_directions(int from, int to, int mode);
char *whichheading(int from, int to, int mode, char *buf);
int cmd_from_dirchar(char d);
int exit_order(int which_order, int nth);
int whichway(int from, int to, int mode);
struct allpoints *apsp(int seed,int mode);
void pather_init(void);

#endif
